<template>
  <Breadcrump :title="$t('users')"></Breadcrump>

  <div class="row">
    <div class="col-lg-12">
      <div class="card">
        <div class="card-body">
          <router-link
            v-if="role != 'Super Admin'"
            class="new-button btn btn-success waves-light waves-effect"
            :to="{ name: 'newUser' }"
          >
            <i class="fa fa-plus"></i>
          </router-link>
          <div class="form-group row">
            <div class="col-sm-12">
              <label for="example-text-input" class="col-sm-2 col-form-label">{{
                $t("search")
              }}</label>
            </div>
            <div class="col-sm-10">
              <input
                class="form-control"
                v-model="searchText"
                type="text"
                id="example-text-input"
              />
            </div>
            <div class="col-sm-2">
              <button
                type="button"
                class="btn btn-outline-success waves-effect waves-light"
                @click="filterUser()"
              >
                Filtrele
              </button>
              <button
                type="button"
                class="btn btn-outline-success waves-effect waves-light"
                @click="clearFilter()"
              >
                Temizle
              </button>
            </div>
          </div>

          <div class="table-responsive">
            <table class="table table-bordered mb-0">
              <thead>
                <tr>
                  <th>#</th>
                  <th>{{ $t("name") }}</th>
                  <th>{{ $t("email") }}</th>
                  <th>{{ $t("role") }}</th>
                  <th>{{ $t("createdAt") }}</th>
                  <th width="20%" v-if="role != 'Super Admin'">
                    {{ $t("actions") }}
                  </th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="(user, index) in users" :key="user.id">
                  <th scope="row">{{ index + 1 }}</th>
                  <td>{{ user.name }}</td>
                  <td>{{ user.email }}</td>
                  <td>{{ user.roles[0].name }}</td>
                  <td>{{ moment(user.created_at).format("DD.MM.YYYY") }}</td>
                  <td v-if="role != 'Super Admin'">
                    <div class="button-items">
                      <router-link
                        :to="{ name: 'newUser', params: { id: user.id } }"
                        class="btn btn-info"
                        >{{ $t("edit") }}</router-link
                      >
                      <button
                        class="btn btn-danger"
                        @click="removeUser(user.id, user)"
                      >
                        {{ $t("delete") }}
                      </button>
                    </div>
                  </td>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import { RouterLink } from "vue-router";
import Breadcrump from "../../components/Breadcrump.vue";
import { useUserStore } from "../../stores/users";
import { storeToRefs } from "pinia";
import { computed, onMounted } from "@vue/runtime-core";
import { useAuthStore } from "../../stores/auth";
import { ref } from "vue";
import moment from "moment";
import { inject } from 'vue'
import i18n from '../../libs/i18n'

const userStore = useUserStore();
const { role } = storeToRefs(useAuthStore);
const { users, searchUser } = storeToRefs(userStore);

const swal = inject('$swal')

const searchText = ref("");

const filterUser=()=>{
  userStore.searchUser(searchText.value)
}
const clearFilter=()=>{
  userStore.fetchUser();
  searchText.value=''
}
const removeUser = (val, user) => {
  swal({
    title: i18n.global.t('warning'),
    text: i18n.global.t('deleteText'),
    type: "info",
    showCancelButton: true,
    confirmButtonColor: "#36c6d3",
    cancelButtonColor: "#d33",
    confirmButtonText: i18n.global.t('yes'),
    cancelButtonText: i18n.global.t('no'),
  }).then((result) =>  {
    if (result.value) {
      userStore.deleteUser(val, user);
      swal(
        i18n.global.t('deleted'),
        i18n.global.t('deletedMessage'),
        "success"
      )
    } else if (result.dismiss == "cancel") {
      swal(i18n.global.t('onCanceled'), i18n.global.t('dataSafe'), "error")
    }
  });
  
};
onMounted(() => {
  userStore.fetchUser();
});
</script>

<style scoped>
.new-button {
  position: fixed;
  top: 92%;
  border-radius: 50%;
  font-weight: 800;
  right: 2%;
}
</style>